#define __IINFO_H

class ictrller;

class iinfo                           /* base class for any install info class */
{
   public:

   iinfo(ictrller &icx):ic(icx)
   {

   }
   virtual ~iinfo()            /* we need to delete a generic install info obj */
   {

   }

   ictrller &ic;                         /* the controller we are working with */

   virtual int getnobktxts()                 = 0;
   virtual int getnoaddlgs()                 = 0;
   virtual int getnoregkeys()                = 0;
   virtual int getregkroot(int i)            = 0;
   virtual int chkdebug()                    = 0;
   virtual int chkendpm()                    = 0;
   virtual int getnobcomps()                 = 0;
   virtual int getnolcomps()                 = 0;
   virtual int getnofiles()                  = 0;
   virtual int getnoitems()                  = 0;
   virtual int getblksize()                  = 0;
   virtual int getnoblksca()                 = 0;
   virtual int getnoblksup()                 = 0;
   virtual int chkbktxti(int i)              = 0;
   virtual int chkbktxtb(int i)              = 0;
   virtual int chkchkver(int i)              = 0;
   virtual int chkshared(int i)              = 0;
   virtual int chkcompressed(int i)          = 0;
   virtual int chkgrantallaccess(int i)      = 0;
   virtual int chkwaitprgm()                 = 0;
   virtual int chkbeforedone()               = 0;
   virtual int getmintime()                  = 0;
   virtual int getbktxth(int i)	            = 0;
   virtual int getbktxtx(int i)	            = 0;
   virtual int getbktxty(int i)              = 0;
   virtual int getcompw1()                   = 0;
   virtual int getcompw2()                   = 0;
   virtual int getcomph()                    = 0;
   virtual int getbcompinisks(int i)         = 0;
   virtual int getbcompnokids(int i)         = 0;
   virtual int getbcompkid(int i, int j)     = 0;
   virtual int getlcompinichk(int i)         = 0;
   virtual int getlcompcanchk(int i)         = 0;
   virtual int getlcompnofkids(int i)        = 0;
   virtual int getlcompnoikids(int i)        = 0;
   virtual int getlcompnoekids(int i)        = 0;
   virtual int getlcompnorkids(int i)        = 0;
   virtual int getlcompfkid(int i, int j)    = 0;
   virtual int getlcompikid(int i, int j)    = 0;
   virtual int getlcompekid(int i, int j)    = 0;
   virtual int getlcomprkid(int i, int j)    = 0;
   virtual int getnoinientries()             = 0;
   virtual int getitemiidx(int i)            = 0;
   virtual LONG getfilesize(int i)           = 0;
   virtual char *getregkpath(int i)          = 0;
   virtual char *getregfield(int i)          = 0;
   virtual char *getregvalue(int i)          = 0;
   virtual char *getinientryfile(int i)      = 0;
   virtual char *getinientrysect(int i)      = 0;
   virtual char *getinientryentry(int i)     = 0;
   virtual char *getinientryvalue(int i)     = 0;
   virtual char *getbktxt(int i)             = 0;
   virtual char *getbktxtf(int i)            = 0;
   virtual char *getdefdir()                 = 0;
   virtual char *getappname()                = 0;
   virtual char *getweltxt1()                = 0;
   virtual char *getweltxt2()                = 0;
   virtual char *getweltxt3()                = 0;
   virtual char *getprgmcmdl()               = 0;
   virtual char *getfilesdir(int i)          = 0;
   virtual char *getfileddir(int i)          = 0;
   virtual char *getfiledesc(int i)          = 0;
   virtual char *getfilename(int i)          = 0;
   virtual char *getfiledisk(int i)          = 0;
   virtual char *getitemname(int i)          = 0;
   virtual char *getitemgrup(int i)          = 0;
   virtual char *getitemcmdl(int i)          = 0;
   virtual char *getitemicon(int i)          = 0;
   virtual char *getitemdirw(int i)          = 0;
   virtual char *getbcompname(int i)         = 0;
   virtual char *getlcompname(int i)         = 0;
   virtual char *getaddlgname(int i)         = 0;
   virtual COLORREF getbktxtc(int i)         = 0;

   char *getdirw();
   char *getdiry();
   char *getdirs();
   char *getdiri();
};

